/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
"use strict";

const ReadFileCompileWasmMainTemplatePlugin = require("./ReadFileCompileWasmMainTemplatePlugin");
const WasmModuleTemplatePlugin = require("../wasm/WasmModuleTemplatePlugin");

class ReadFileCompileWasmTemplatePlugin {
	apply(compiler) {
		compiler.hooks.thisCompilation.tap("ReadFileCompileWasmTemplatePlugin", (compilation) => {
			compilation.mainTemplate.apply(new ReadFileCompileWasmMainTemplatePlugin());
			compilation.moduleTemplates.javascript.apply(new WasmModuleTemplatePlugin());
		});
	}
}

module.exports = ReadFileCompileWasmTemplatePlugin;
